//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  DarkOrange
#property indicator_color3  Gray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int    MaPeriod      = 20;
extern int    MaMethod      = MODE_SMA;
extern int    PriceToUse    = PRICE_TYPICAL;
extern int    AtrPeriod     = 50;
extern double AtrMultiplier = 2.5;
extern int    MaAtrShift    = 1;
extern string MaMethods     = "";
extern string _0            = "0 - SMA";
extern string _1            = "1 - EMA";
extern string _2            = "2 - SMMA";
extern string _3            = "3 - LWMA";

//
//
//
//
//

double bup[];
double bdn[];
double hne[];
double hup[];
double hdn[];
double price[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,hup); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,hdn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,hne); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,bup);
   SetIndexBuffer(4,bdn);
   SetIndexBuffer(5,price);
      IndicatorShortName("Keltner channel oscillator ("+MaPeriod+","+DoubleToStr(AtrMultiplier,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i = limit; i >= 0; i--)
      {
         double tprice = iMA(NULL,0,1       ,0,MODE_SMA,PriceToUse,i+MaAtrShift);
         double ma     = iMA(NULL,0,MaPeriod,0,MaMethod,PriceToUse,i+MaAtrShift);
         double atr    = iATR(NULL,0,AtrPeriod,i+MaAtrShift);
            price[i] =  tprice-ma;
            bup[i]   =  AtrMultiplier*atr;
            bdn[i]   = -AtrMultiplier*atr;
            hup[i]   =  EMPTY_VALUE;
            hdn[i]   =  EMPTY_VALUE;
            hne[i]   =  EMPTY_VALUE;
               if (price[i]>bup[i]) hup[i] = 1;
               if (price[i]<bdn[i]) hdn[i] = 1;
               if (hup[i] == EMPTY_VALUE && hdn[i] == EMPTY_VALUE) hne[i] = 1;
      }
   return(0);
}